# coding: utf-8

"""
    API V1

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: v1

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import sys
import os
import re
import time

from .pdf_api import PDFApi

class PollTimeoutError(Exception):
    pass

class Client(PDFApi):
    """
      FormAPI API Client
    """

    def generate_pdf(self, data, **kwargs):
        """
        Generates a new PDF and waits for PDF to be ready.
        :param Data data:
        :return: InlineResponse2011
        """
        template_id = data.get('template_id')
        del data['template_id']

        kwargs['data'] = data
        kwargs['_return_http_data_only'] = True

        (data) = self.generate_pdf_with_http_info(template_id, **kwargs)

        submission = data.submission

        start_time = time.time()
        timeout = 60
        if 'timeout' in kwargs and kwargs['timeout'] is not None:
            timeout = kwargs['timeout']

        # Wait for submission to be ready
        while (submission.state == 'pending'):
            time.sleep(1)
            submission = self.get_submission(submission.id)

            if time.time() - start_time > timeout:
                raise PollTimeoutError("PDF was not ready after %d seconds!" % timeout)

        return submission


    def combine_submissions(self, data, **kwargs):
        """
        Combines multiple submissions into a single PDF, and waits for merged PDF to be ready.
        :param Data data
        :return: InlineResponse201
        """
        kwargs['data'] = data
        kwargs['_return_http_data_only'] = True

        (data) = self.combine_submissions_with_http_info(**kwargs)

        combined_submission = data.combined_submission

        start_time = time.time()
        timeout = 60
        if 'timeout' in kwargs and kwargs['timeout'] is not None:
            timeout = kwargs['timeout']

        # Wait for submission to be ready
        while (combined_submission.state == 'pending'):
            time.sleep(1)
            combined_submission = self.get_combined_submission(combined_submission.id)

            if time.time() - start_time > timeout:
                raise PollTimeoutError("Merged PDF was not ready after %d seconds!" % timeout)

        return combined_submission
